# PW Lazy Loader

Lazy loader with the following features:

* Follows the progressive enhancement strategy: Old browsers (not supporting `<template>`) will view the content.
* Works with any kind of content: images, videos, iframes, scripts, etc
* Build with ES6 and modern tools (webpack, babel, etc)
* Easy to extend and adapt to your needs

## Install

Requirements:

* NPM to install the [package and the dependencies](https://www.npmjs.com/package/pw-lazy-loader)
* Webpack (or any other javascript loader)

```
npm install pw-lazy-loader
```

## Usage

This library scan for all `template[data-lazyload]` elements and load the content when the element enter in the viewport. It creates also a svg element as placeholder while the final html is not loaded.

### Html

Let's say we have the following html code:

```html
<template data-lazyload>
    <img src="some-big-image.jpg">
</template>

<!-- Optional but recomended for users without javascript -->
<noscript>
	<img src="some-big-image.jpg">
</noscript>
```

### JS

Init the library:

```js
import LazyLoader from 'pw-lazy-loader';

var loader = new LazyLoader();
loader.init();
```

## Demo

To run the demo, just clone this repository enter in the directory and execute:

```sh
npm install
npm start
```

You should see something in `http://localhost:8080/`
