'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _d_js = require('d_js');

var _d_js2 = _interopRequireDefault(_d_js);

var _intersectionObserver = require('intersection-observer');

var _intersectionObserver2 = _interopRequireDefault(_intersectionObserver);

var _queue = require('./queue');

var _queue2 = _interopRequireDefault(_queue);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var LazyLoader = function () {
    function LazyLoader(el) {
        _classCallCheck(this, LazyLoader);

        if (!isSupported()) {
            return;
        }

        this.element = el || document;
        this.events = {};
        this.placeholderSize = '100x100';
        this.queue = new _queue2.default();
    }

    _createClass(LazyLoader, [{
        key: 'on',
        value: function on(event, callback) {
            if (!this.events[event]) {
                this.events[event] = [];
            }

            this.events[event].push(callback);
        }
    }, {
        key: 'off',
        value: function off(event, callback) {
            if (this.events[event]) {
                if (!callback) {
                    delete this.events[event];
                } else {
                    var index = this.events[event].indexOf(callback);

                    if (index !== -1) {
                        this.events[event].splice(index, 1);
                    }
                }
            }
        }
    }, {
        key: 'trigger',
        value: function trigger(event) {
            var _this = this;

            var args = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];

            if (this.events[event]) {
                this.events[event].forEach(function (callback) {
                    return callback.apply(_this, args);
                });
            }
        }
    }, {
        key: 'init',
        value: function init(template) {
            var _this2 = this;

            if (this.observer) {
                return;
            }

            this.observer = new IntersectionObserver(function (entries) {
                entries.forEach(function (entry, index) {
                    if (entry.isIntersecting) {
                        _this2.queue.add(entry.target, function (done) {
                            _this2.observer.unobserve(entry.target);
                            _this2.load(entry.target, done);
                        });
                    } else {
                        _this2.queue.remove(entry.target);
                    }
                });
            });

            _d_js2.default.getAll('template[data-lazyload]').forEach(function (template) {
                return _this2.createPlaceholder(template);
            });
        }
    }, {
        key: 'createPlaceholder',
        value: function createPlaceholder(template) {
            var _split = (template.dataset.size || this.placeholderSize).split('x'),
                _split2 = _slicedToArray(_split, 2),
                width = _split2[0],
                height = _split2[1];

            var svg = _d_js2.default.parse('<svg xmlns=\'http://www.w3.org/2000/svg\' width="' + width + '" height="' + height + '" viewBox="0 0 ' + width + ' ' + height + '"></svg>').firstChild;

            template.after(svg);
            this.observer.observe(svg);
        }
    }, {
        key: 'load',
        value: function load(svg, done) {
            var template = svg.previousElementSibling;
            var content = document.importNode(template.content, true);
            template.remove();

            this.replace(content, svg, function () {
                return done();
            });
        }
    }, {
        key: 'replace',
        value: function replace(content, svg, done) {
            svg.replaceWith(svg);
            done();
        }
    }, {
        key: 'destroy',
        value: function destroy() {
            this.observer.disconnect();

            _d_js2.default.getAll('noscript').forEach(function (noscript) {
                var svg = noscript.nextElementSibling;

                if (svg.matches('svg')) {
                    svg.remove();
                }
            });
        }
    }]);

    return LazyLoader;
}();

exports.default = LazyLoader;


function isSupported() {
    return 'content' in document.createElement('template');
}