"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Queue = function () {
    function Queue() {
        _classCallCheck(this, Queue);

        this.timeout = 100;
        this.parallel = 2;
        this.executing = 0;
        this.callbacks = [];
        this.targets = [];
    }

    _createClass(Queue, [{
        key: "has",
        value: function has(target) {
            return this.targets.indexOf(target) !== -1;
        }
    }, {
        key: "add",
        value: function add(target, callback) {
            if (!this.has(target)) {
                this.targets.push(target);
                this.callbacks.push(callback);
            }

            this.run();
        }
    }, {
        key: "remove",
        value: function remove(target) {
            var index = this.targets.indexOf(target);

            if (index !== -1) {
                this.targets.splice(index, 1);
                this.callbacks.splice(index, 1);
            }
        }
    }, {
        key: "run",
        value: function run() {
            var _this = this;

            while (this.executing < this.parallel && this.targets.length) {
                ++this.executing;
                this.targets.shift();
                var callback = this.callbacks.shift();

                callback(function () {
                    setTimeout(function () {
                        --_this.executing;
                        _this.run();
                    }, _this.timeout);
                });
            }
        }
    }]);

    return Queue;
}();

exports.default = Queue;